with Claw,
     Claw.Static,
     Claw.Push_Button,
     Claw.Dialog.Modal;
package About_Dialog is

    -- This package implements a dialog to show text and wait for OK.

    --  -------------------------
    --  |   Title goes here     |
    --  |                       |
    --  |       Text1           |
    --  |       Text2           |
    --  |       Textn           |
    --  |                       |
    --  |        OK             |
    --  -------------------------

    type Text_Array is array(Positive range <>,Positive range <>) of Character;

    procedure Use_Dialog_Box (Owner : in out Claw.Root_Window_Type'Class;
                              Title : in     String;
                              Text  : in     Text_Array);
    -- Called from a menu selection and returns after OK.

private

    type Line_Boxes is array(Integer range <>) of Claw.Static.Static_Type;

    type Dialog_Type(String_Count, String_Length : Positive)
    is new Claw.Dialog.Modal.Modal_Dialog_Type with record
        Height,
        Width     : Claw.Int;  -- dialog units
        Text      : Text_Array(1 .. String_Count, 1 .. String_Length);
        Line_Box  : Line_Boxes(1 .. String_Count);
        OK_Button : Claw.Push_Button.Button_Type;
    end record;

    -- Override the following:
    procedure When_Initialize (Dialog : in out Dialog_Type;
                               Windows_Set_Focus : in out Boolean);

    procedure When_OK (Dialog : in out Dialog_Type);


end About_Dialog;
